﻿Public Class Form1
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim cf As New RightTabAlignCreationFilter
        UltraTabControl1.Tabs.TabControl.CreationFilter = cf
    End Sub
End Class

Public Class RightTabAlignCreationFilter
    Implements IUIElementCreationFilter

    Dim tab1Width As Integer

    Public Function BeforeCreateChildElements(parent As UIElement) As Boolean Implements Infragistics.Win.IUIElementCreationFilter.BeforeCreateChildElements
        Return False
    End Function

    Public Sub AfterCreateChildElements(parent As UIElement) Implements Infragistics.Win.IUIElementCreationFilter.AfterCreateChildElements
        Dim tabRow As TabRowUIElement

        If TypeOf parent Is TabRowUIElement Then
            tabRow = parent

            If IsNothing(tabRow) = False Then
                For Each tabItem As TabItemUIElement In tabRow.ChildElements
                    If tabItem.TabItem.Index = CType(tabItem.Control, UltraTabControl).Tabs.Count - 1 Then
                        tabRow = CType(tabItem.Parent, TabRowUIElement)
                        tabItem.Rect = New Rectangle((tabRow.Rect.X + tabRow.Rect.Width - tabItem.Rect.Width), tabItem.Rect.Y, tabItem.Rect.Width, tabItem.Rect.Height)

                        'Set the Tab1 width
                        tab1Width = tabItem.Rect.Width
                    ElseIf tabItem.TabItem.Index = CType(tabItem.Control, UltraTabControl).Tabs.Count - 2 Then
                        tabRow = CType(tabItem.Parent, TabRowUIElement)

                        'Subtract the width for Tab1...
                        tabItem.Rect = New Rectangle((tabRow.Rect.X + tabRow.Rect.Width - tabItem.Rect.Width - tab1Width), tabItem.Rect.Y, tabItem.Rect.Width, tabItem.Rect.Height)
                    End If
                Next
            End If
        End If
    End Sub
End Class
